# #############################################################################
# Public Auto Observe v0.0.3
# Script to allow public players to auto observe hackers and such.
#
# Author: Neptune | neptune@cmgsourceclan.com
# Date: 09/04/2010
#
# #############################################################################

# #############################################################################
# Python Imports required for this addon
# #############################################################################

# Import required Extensions
import es
import playerlib
import popuplib

# #############################################################################
# Mod Information
# #############################################################################
# Set the name of the mod as a variable for convenience
modName = "#default#green[Auto-Observe]#default"
modVersion = "0.0.3"

# #############################################################################
# Global Events
# #############################################################################

def load():
 if(es.exists("keygroup","neptune_pao_pairing")):
  es.keygroupdelete("neptune_pao_pairing")
 es.keygroupcreate("neptune_pao_pairing")
 es.keycreate("neptune_pao_pairing", "observed")
 es.keycreate("neptune_pao_pairing", "spectating")

 
 # Setup to listen for !observe chat command 
 if(es.exists('command', '!observe') == 1):
  es.unregsaycmd('!observe')
  es.server.cmd("ma_chat !observe command disabled.")
 es.server.cmd("ma_chat !observe command enabled.")
 es.regsaycmd('!observe', 'neptune_observe/throwPopUp', 'Open menu.')
 
 es.msg("#multi", modName + " loaded...")
 
 
def es_map_start(event_var):
 if(es.exists("keygroup","neptune_pao_pairing")):
  es.keygroupdelete("neptune_pao_pairing")
 es.keygroupcreate("neptune_pao_pairing")
 es.keycreate("neptune_pao_pairing", "observed")
 es.keycreate("neptune_pao_pairing", "spectating")
 
def unload():
 es.keygroupdelete("neptune_pao_pairing")
 es.unregsaycmd('!observe')
 es.msg("#multi", modName + " unloaded...")
 
 
def player_spawn(event_var):
 if(es.exists('keyvalue', 'neptune_pao_pairing', 'observed', event_var['userid'])):
  observer = es.keygetvalue('neptune_pao_pairing', 'observed', event_var['userid'])
  if( observer > 0):
   setView(observer, event_var['userid'])
   
def player_death(event_var):
 if(es.exists('keyvalue', 'neptune_pao_pairing', 'spectating', event_var['userid'])):
  target = es.keygetvalue('neptune_pao_pairing', 'spectating', event_var['userid'])
  if( target > 0):
   setView(event_var['userid'], target)
 

def player_disconnect(event_var):
 userid = event_var['userid']
 remItem(userid, userid)

 
# #############################################################################
# Custom Events / Functions for script functionality
# #############################################################################

# ####################################
# Add Pairing to Keygroup
# ####################################
def addItem(observer, target):
 if(es.exists('keyvalue', 'neptune_pao_pairing', 'spectating', observer)):
  priortarget = es.keygetvalue('neptune_pao_pairing', 'spectating', observer)
  es.keysetvalue('neptune_pao_pairing', 'observed', priortarget, '0')
 es.keysetvalue('neptune_pao_pairing', 'observed', target, observer)
 es.keysetvalue('neptune_pao_pairing', 'spectating', observer, target)

# ####################################
# Set pairing in keygroup to 0's
# ####################################
def remItem(observer, target):
 if(target > 0):
  if(es.exists('keyvalue', 'neptune_pao_pairing', 'observed', target)):
   priorobserver = es.keygetvalue('neptune_pao_pairing', 'observed', target)
   es.keysetvalue('neptune_pao_pairing', 'observed', target, '0')
  if(es.exists('keyvalue', 'neptune_pao_pairing', 'spectating', priorobserver)):
   es.keysetvalue('neptune_pao_pairing', 'spectating', priorobserver, '0')
 if(observer > 0):
  if(es.exists('keyvalue', 'neptune_pao_pairing', 'spectating', observer)):
   priortarget = es.keygetvalue('neptune_pao_pairing', 'spectating', observer)
   es.keysetvalue('neptune_pao_pairing', 'observed', priortarget, '0')
  if(es.exists('keyvalue', 'neptune_pao_pairing', 'spectating', observer)):
   es.keysetvalue('neptune_pao_pairing', 'spectating', observer, '0')

# ####################################
# Change players viewpoint
# ####################################
def setView(observer, target):
 if(target != 0):
  playerTeam = playerlib.getPlayer(observer).teamid
  if(playerTeam == 1):
   local = getTarget(int(target))
   player = playerlib.getPlayer(target)
   if(player.isdead != 1):
    es.setplayerprop(observer, "CCSPlayer.baseclass.m_iObserverMode", 4)
    es.setplayerprop(observer, "CCSPlayer.baseclass.m_hObserverTarget", local) 
    es.tell(observer, "#multi", modName + " Observing: %s [%s]" % (player.name, player.steamId))

# ####################################
# Convert a userid into an entid
# ####################################
def getTarget(userid):
 player = playerlib.getPlayer(userid)
 return player.handle
 

# ####################################
# popUpParser | handle menu choice
# ####################################   
def popUpParser(userid,choice,menu):
 playerListPopUp[menu].delete() # Cleanup
 addItem(userid, choice)
 setView(userid, choice)
 


# ####################################
# initializePopUp | prepare menu for sending
# ####################################
def initializePopUp(steamId):
 global playerListPopUp
 # Create a new Popup_easymenu object using the easymenu method from popuplib,
 # Notice the last parameter, which specifies the method to be used for callback:
 playerListPopUp = {}
 playerListPopUp[steamId] = popuplib.easymenu(steamId,None,popUpParser)
 # Set a title for the menu:
 playerListPopUp[steamId].settitle("Auto Observe Menu:")
 # add some menu items to it: 
 playerList = playerlib.getPlayerList('#ct')
 for x in playerList:
  playerListPopUp[steamId].addoption(x,playerlib.getPlayer(x).name)
 playerList = playerlib.getPlayerList('#t')
 for x in playerList:
  playerListPopUp[steamId].addoption(x,playerlib.getPlayer(x).name)
 

# ####################################
# throwPopUp | send the menu to the user
# ####################################
def throwPopUp():
 userid = es.getcmduserid()
 thisPlayer = playerlib.getPlayer(userid)
 initializePopUp(thisPlayer.steamId)
 playerListPopUp[thisPlayer.steamId].send(thisPlayer.userid)
